
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class WebhooksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhooks = await db.webhooks.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        target_url: data.target_url
        ||
        null
            ,
            
        secret: data.secret
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        event_types: data.event_types
        ||
        null
            ,
            
        timeout_seconds: data.timeout_seconds
        ||
        null
            ,
            
        max_retries: data.max_retries
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await webhooks.setTenant( data.tenant || null, {
            transaction,
        });
        
        await webhooks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return webhooks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const webhooksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                target_url: item.target_url
            ||
            null
            ,
            
                secret: item.secret
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                event_types: item.event_types
            ||
            null
            ,
            
                timeout_seconds: item.timeout_seconds
            ||
            null
            ,
            
                max_retries: item.max_retries
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const webhooks = await db.webhooks.bulkCreate(webhooksData, { transaction });

        // For each item created, replace relation files
        

        return webhooks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const webhooks = await db.webhooks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.target_url !== undefined) updatePayload.target_url = data.target_url;
        
        
        if (data.secret !== undefined) updatePayload.secret = data.secret;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.event_types !== undefined) updatePayload.event_types = data.event_types;
        
        
        if (data.timeout_seconds !== undefined) updatePayload.timeout_seconds = data.timeout_seconds;
        
        
        if (data.max_retries !== undefined) updatePayload.max_retries = data.max_retries;
        
        
        updatePayload.updatedById = currentUser.id;

        await webhooks.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await webhooks.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await webhooks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return webhooks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const webhooks = await db.webhooks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of webhooks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of webhooks) {
                await record.destroy({transaction});
            }
        });


        return webhooks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const webhooks = await db.webhooks.findByPk(id, options);

        await webhooks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await webhooks.destroy({
            transaction
        });

        return webhooks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const webhooks = await db.webhooks.findOne(
            { where },
            { transaction },
        );

        if (!webhooks) {
            return webhooks;
        }

        const output = webhooks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.webhook_deliveries_webhook = await webhooks.getWebhook_deliveries_webhook({
            transaction
        });
        
        
        
        
        
        
        
        output.tenant = await webhooks.getTenant({
            transaction
        });
        
        
        output.organizations = await webhooks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhooks',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.target_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhooks',
                        'target_url',
                        filter.target_url,
                    ),
                };
            }
            
            if (filter.secret) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhooks',
                        'secret',
                        filter.secret,
                    ),
                };
            }
            
            if (filter.event_types) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'webhooks',
                        'event_types',
                        filter.event_types,
                    ),
                };
            }
            

            
            

            
            if (filter.timeout_secondsRange) {
                const [start, end] = filter.timeout_secondsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    timeout_seconds: {
                    ...where.timeout_seconds,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    timeout_seconds: {
                    ...where.timeout_seconds,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_retriesRange) {
                const [start, end] = filter.max_retriesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_retries: {
                    ...where.max_retries,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_retries: {
                    ...where.max_retries,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.webhooks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'webhooks',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.webhooks.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

